program demo;

uses
  windows,
  messages,
  enZGLine;

type
  TVerticle = record
    Vertex: TVector3D;
    Tex1  : TVector2D;
    Tex2  : TVector2D;
  end;

var
  mode: TMode = (ResX         : 800;
                 ResY         : 600;
                 bpp          : 32;
                 full         : false;
                 Freq         : -1;
                 AntiAliasing : false;
                 Samples      : -1;
                 Anisotropy   : true;
                 v_sync       : false;);
  Qube: array[0..7] of TVerticle;
  Indexes: array[0..35] of WORD;

  V_Buf, I_Buf: TGLBuffer;
  T_Main, T_Sec: TGLTexture;
  angle: Single = 0;

  T_Buf: TGLTexture;
  F_Obj: TGLFBuffer;

  Water: array[0..3] of TVerticle;
  T_Water: TGLTexture;

procedure Init;
var
  p: pointer;
begin
  fsys.AddPacksDir('Data');

  Qube[0].Vertex := math3D.NewVector3D(-1,-1,-1);
  Qube[1].Vertex := math3D.NewVector3D(-1, 1,-1);
  Qube[2].Vertex := math3D.NewVector3D( 1, 1,-1);
  Qube[3].Vertex := math3D.NewVector3D( 1,-1,-1);
  Qube[4].Vertex := math3D.NewVector3D(-1,-1, 1);
  Qube[5].Vertex := math3D.NewVector3D(-1, 1, 1);
  Qube[6].Vertex := math3D.NewVector3D( 1, 1, 1);
  Qube[7].Vertex := math3D.NewVector3D( 1,-1, 1);

  Qube[0].Tex1 := math3D.NewVector2D(0,0);
  Qube[1].Tex1 := math3D.NewVector2D(1,0);
  Qube[2].Tex1 := math3D.NewVector2D(1,1);
  Qube[3].Tex1 := math3D.NewVector2D(0,1);
  Qube[4].Tex1 := math3D.NewVector2D(1,1);
  Qube[5].Tex1 := math3D.NewVector2D(0,1);
  Qube[6].Tex1 := math3D.NewVector2D(0,0);
  Qube[7].Tex1 := math3D.NewVector2D(1,0);

  Qube[0].Tex2 := math3D.NewVector2D(0,0);
  Qube[1].Tex2 := math3D.NewVector2D(1,0);
  Qube[2].Tex2 := math3D.NewVector2D(1,1);
  Qube[3].Tex2 := math3D.NewVector2D(0,1);
  Qube[4].Tex2 := math3D.NewVector2D(1,1);
  Qube[5].Tex2 := math3D.NewVector2D(0,1);
  Qube[6].Tex2 := math3D.NewVector2D(0,0);
  Qube[7].Tex2 := math3D.NewVector2D(1,0);

  Indexes[00] := 0;
  Indexes[01] := 1;
  Indexes[02] := 2;

  Indexes[03] := 0;
  Indexes[04] := 2;
  Indexes[05] := 3;

  Indexes[06] := 3;
  Indexes[07] := 2;
  Indexes[08] := 6;

  Indexes[09] := 3;
  Indexes[10] := 6;
  Indexes[11] := 7;

  Indexes[12] := 7;
  Indexes[13] := 6;
  Indexes[14] := 5;

  Indexes[15] := 7;
  Indexes[16] := 5;
  Indexes[17] := 4;

  Indexes[18] := 4;
  Indexes[19] := 5;
  Indexes[20] := 1;

  Indexes[21] := 4;
  Indexes[22] := 1;
  Indexes[23] := 0;

  Indexes[24] := 1;
  Indexes[25] := 5;
  Indexes[26] := 6;

  Indexes[27] := 1;
  Indexes[28] := 6;
  Indexes[29] := 2;

  Indexes[30] := 7;
  Indexes[31] := 3;
  Indexes[32] := 0;

  Indexes[33] := 7;
  Indexes[34] := 0;
  Indexes[35] := 4;

  V_Buf := vbo.NewID(224,BUF_DATA,@Qube[0],'V_Buf');     //224 = (3*4+2*4+2*4)*8
  I_Buf := vbo.NewID(72,BUF_ELEMENT,@Indexes[0],'I_Buf');//72  = 36*2

  T_Main := tex2D.LoadTexture('Data\Main.tga',true,true);
  T_Sec  := tex2D.LoadTexture('Data\sec.jpg',true,true);

  GetMem(p,512*512*3);
  T_Buf := tex2D.NewID(p,512,512,GL_RGB,true,true,'*REF*',-1);
  F_Obj := fbo.NewID(512,512,'*FBO_REFL*',-1,true);
  T_Water := tex2D.LoadTexture('Data\Water.jpg',true,true);

  Water[0].Vertex := math3D.NewVector3D(-5,-5,  -5);
  Water[1].Vertex := math3D.NewVector3D( 5,-5,  -5);
  Water[2].Vertex := math3D.NewVector3D( 5,-5, 5);
  Water[3].Vertex := math3D.NewVector3D(-5,-5, 5);

  Water[2].Tex1 := math3D.NewVector2D(0,0);
  Water[3].Tex1 := math3D.NewVector2D(1,0);
  Water[0].Tex1 := math3D.NewVector2D(1,1);
  Water[1].Tex1 := math3D.NewVector2D(0,1);

  Water[0].Tex2 := Water[0].Tex1;
  Water[1].Tex2 := Water[1].Tex1;
  Water[2].Tex2 := Water[2].Tex1;
  Water[3].Tex2 := Water[3].Tex1;
end;

procedure Free;
begin

end;

procedure Update;
begin
  if inp.KeyDown(VK_ESCAPE) then eng.Quit;
  angle := angle + 0.5;
end;

procedure Render_Box;
begin
//  ogl.Blend(BLEND_SUB);

  vbo.Enable(V_Buf,I_Buf);
  vbo.EnableArray(ARR_VERTEX);
  vbo.EnableArray(ARR_TEXCOORD);
  vbo.EnableArray(ARR_TEXCOORD);

  vbo.VertexPointer(28,0,3);
  vbo.TexCoordPointer(28,12,2,0);
  vbo.TexCoordPointer(28,20,2,1);

  tex2D.EnvSetup(TEXENV_TEXTURE_ENV_MODE,    TEXENV_COMBINE_ARB    );
  tex2D.EnvSetup(TEXENV_COMBINE_RGB_ARB,     TEXENV_INTERPOLATE_ARB);
  tex2D.EnvSetup(TEXENV_COMBINE_ALPHA_ARB,   TEXENV_REPLACE    );

  tex2D.EnvSetup(TEXENV_SOURCE0_RGB_ARB,     TEXENV_PREVIOUS_ARB  );
  tex2D.EnvSetup(TEXENV_OPERAND0_RGB_ARB,    TEXENV_SRC_COLOR     );
  tex2D.EnvSetup(TEXENV_OPERAND0_ALPHA_ARB,  TEXENV_PREVIOUS_ARB  );
  tex2D.EnvSetup(TEXENV_OPERAND0_ALPHA_ARB,  TEXENV_SRC_ALPHA     );

  tex2D.EnvSetup(TEXENV_SOURCE1_RGB_ARB,     TEXENV_TEXTURE     );
  tex2D.EnvSetup(TEXENV_OPERAND1_RGB_ARB,    TEXENV_SRC_COLOR   );
  tex2D.EnvSetup(TEXENV_SOURCE1_ALPHA_ARB,   TEXENV_TEXTURE     );
  tex2D.EnvSetup(TEXENV_OPERAND1_ALPHA_ARB,  TEXENV_SRC_ALPHA   );

  tex2D.EnvSetup(TEXENV_SOURCE2_RGB_ARB,     TEXENV_PREVIOUS_ARB);
  tex2D.EnvSetup(TEXENV_OPERAND2_RGB_ARB,    TEXENV_SRC_ALPHA   );
  tex2D.EnvSetup(TEXENV_SOURCE2_ALPHA_ARB,   TEXENV_TEXTURE     );
  tex2D.EnvSetup(TEXENV_OPERAND2_ALPHA_ARB,  TEXENV_PREVIOUS_ARB);

  vbo.RenderBuffer(TRIANGLES,36,0);
//  ogl.Blend(BLEND_NONE);

  vbo.DisableArray(ARR_VERTEX);
  vbo.DisableArray(ARR_TEXCOORD);
  vbo.DisableArray(ARR_TEXCOORD);
  vbo.Disable;
end;

procedure RenderWater;
begin
  tex2D.Enable(T_WATER  ,0,ENV_REPLACE);
  tex2D.Enable(T_Buf    ,1,ENV_MODULATE);
  ogl.SetColor(1,1,1,1);
  ogl.EnablePolygon(QUADS);
   ogl.SetTxCoord(Water[0].Tex1.x,  Water[0].Tex1.y,0);
   ogl.SetTxCoord(Water[0].Tex2.x,  Water[0].Tex2.y,1);
    ogl.SetVertex(Water[0].Vertex.x,Water[0].Vertex.y,Water[0].Vertex.z);
   ogl.SetTxCoord(Water[1].Tex1.x,  Water[1].Tex1.y,0);
   ogl.SetTxCoord(Water[1].Tex2.x,  Water[1].Tex2.y,1);
    ogl.SetVertex(Water[1].Vertex.x,Water[1].Vertex.y,Water[1].Vertex.z);
   ogl.SetTxCoord(Water[2].Tex1.x,  Water[2].Tex1.y,0);
   ogl.SetTxCoord(Water[2].Tex2.x,  Water[2].Tex2.y,1);
    ogl.SetVertex(Water[2].Vertex.x,Water[2].Vertex.y,Water[2].Vertex.z);
   ogl.SetTxCoord(Water[3].Tex1.x,  Water[3].Tex1.y,0);
   ogl.SetTxCoord(Water[3].Tex2.x,  Water[3].Tex2.y,1);
    ogl.SetVertex(Water[3].Vertex.x,Water[3].Vertex.y,Water[3].Vertex.z);
  ogl.DisablePolygon;
  tex2D.Disable(0);
  tex2D.Disable(1);
end;

procedure Render;
begin
  tex2D.Enable2D;
  tex2D.Enable(T_Main,0,ENV_REPLACE);
  tex2D.Enable(T_Sec,1,ENV_REPLACE);
  tex2D.EnableSphereTexCoords;

  fbo.Enable(F_Obj,T_Buf,0);
  ogl.ClearColor(1,1,1,1);
  ogl.Clear(true,true);
  ogl.Set3D(0.1,100.0,90,1.33333333);
  ogl.Translate(0,0,-5);
  ogl.Rotate(angle,1,-2,3);
  ogl.Rotate(180,0,1,0);  
  ogl.SetView(0,0,512,512);
  Render_Box;
  fbo.Disable;
  ogl.ClearColor(0,0,0,0);
  ogl.Clear(true,true);
  ogl.Set3D(0.1,100.0,90,1.33333333);
  ogl.Translate(0,0,-5);
  ogl.Rotate(-angle,1,-2,3);
  Render_Box;

  tex2D.DisableSphereTexCoords;
  tex2D.Disable(0);
  tex2D.Disable(1);

  ogl.Rotate(angle,1,-2,3);
  ogl.Translate(0,-1,2);
  ogl.Rotate(80,1,0,0);
  RenderWater;

  tex2D.Disable;
  ogl.Swap;
end;

procedure Msg(m: uint; w, l: Integer);
begin

end;

begin
  InitENZGLINE(mode);

  eng.SetProc(PROC_INIT,@Init);
  eng.SetProc(PROC_FREE,@Free);
  eng.SetProc(PROC_UPDATE,@Update);
  eng.SetProc(PROC_RENDER,@Render);
  eng.SEtProc(PROC_MSG,@Msg);

  eng.Loop(50);
end.
